/*
 * Snes9x - Portable Super Nintendo Entertainment System (TM) emulator.
 *
 * (c) Copyright 1996, 1997, 1998, 1999 Gary Henderson (gary@daniver.demon.co.uk) and
 *                                      Jerremy Koot (jkoot@snes9x.com)
 *
 * Super FX C emulator code 
 * (c) Copyright 1997, 1998, 1999 Ivar (Ivar@snes9x.com) and
 *                                Gary Henderson.
 * Super FX assembler emulator code (c) Copyright 1998 zsKnight and _Demo_.
 *
 * DSP1 emulator code (c) Copyright 1998 Ivar, _Demo_ and Gary Henderson.
 * DOS port code contains the works of other authors. See headers in
 * individual files.
 *
 * Snes9x homepage: www.snes9x.com
 *
 * Permission to use, copy, modify and distribute Snes9x in both binary and
 * source form, for non-commercial purposes, is hereby granted without fee,
 * providing that this license information and copyright notice appear with
 * all copies and any derived work.
 *
 * This software is provided 'as-is', without any express or implied
 * warranty. In no event shall the authors be held liable for any damages
 * arising from the use of this software.
 *
 * Snes9x is freeware for PERSONAL USE only. Commercial users should
 * seek permission of the copyright holders first. Commercial use includes
 * charging money for Snes9x or software derived from Snes9x.
 *
 * The copyright holders request that bug fixes and improvements to the code
 * should be forwarded to them so everyone can benefit from the modifications
 * in future versions.
 *
 * Super NES and Super Nintendo Entertainment System are trademarks of
 * Nintendo Co., Limited and its subsidiary companies.
 */

#ifndef _PORT_H_
#define _PORT_H_

#define DEBUGGER

// Commment out this line for normal operation
//#define DEBUG_LOADROM

#include "../underce.h"

#include <limits.h>

#include <memory.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>

#define NO_INLINE_SET_GET
#define SPC700_C
//#define GFX_MULTI_FORMAT
#define VAR_CYCLES
#define SPC700_C
#define CPU_SHUTDOWN
#define SPC700_SHUTDOWN
#if defined ZSNES_FX
#undef ZSNES_FX
#endif
//#define EXECUTE_SUPERFX_PER_LINE

//#include <sys/types.h>

#if defined UNDER_CE
#define PIXEL_FORMAT RGB565
#else
#define PIXEL_FORMAT RGB555
#endif

//#define TRACE_CYCLES

#ifndef snes9x_types_defined
#define snes9x_types_defined
typedef unsigned char uint8;
typedef unsigned short uint16;
typedef unsigned int uint32;
typedef unsigned char bool8;
typedef signed char int8;
typedef short int16;
typedef int int32;
#ifndef _WIN32
typedef long long int64;
#else
typedef __int64 int64;
#endif
#endif

#include "pixform.h"

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

#if defined(__cplusplus) || defined(c_plusplus)
#define EXTERN_C extern "C"
#define START_EXTERN_C extern "C" {
#define END_EXTERN_C }
#else
#define EXTERN_C extern
#define START_EXTERN_C
#define END_EXTERN_C
#endif

#define ZeroMemory(a,b) memset((a),0,(b))

#ifdef UNDER_CE
	void _makepath (char *path, const char *drive, const char *dir,
		const char *fname, const char *ext);
	void _splitpath (const char *path, char *drive, char *dir, char *fname,
		 char *ext);
#endif


#ifndef PATH_MAX
#define PATH_MAX 1024
#endif

#define _MAX_DIR PATH_MAX
#define _MAX_DRIVE 1
#define _MAX_FNAME PATH_MAX
#define _MAX_EXT PATH_MAX
#define _MAX_PATH PATH_MAX

#define strcasecmp stricmp
#define strncasecmp strnicmp

EXTERN_C void S9xGenerateSound ();

#define CHECK_SOUND()

#define SLASH_STR "/"
#define SLASH_CHAR '/'

//#if !defined UNDER_CE
#define LSB_FIRST
//#define FAST_LSB_WORD_ACCESS
//#else
//#define MSB_FIRST
//#endif

#ifndef TITLE
#define TITLE "Snes9x"
#endif

#define STATIC static

#endif
